<template>
  <CDataTable
    :fields="fields"
    :items="items"
    pagination
    striped
    size="md"
    class="tableWrapper"
    addTableClasses="usersTable"
  >
    <template #over-table>
      <CButton
        color="primary"
        class="mb-4"
        @click="addUser"
      >
        Пригласить пользователя
      </CButton>
    </template>
    <template #actions="{item}">
      <td
        v-if="item.role !== roles.admin"
        class="actions"
      >
        <CButton
          variant="ghost"
          @click="deleteUser(item)"
        >
          <CIcon
            name="cilTrash"
            class="icon remove"
            size="lg"
          />
        </CButton>
        <CButton
          variant="ghost"
          @click="blockUser(item)"
        >
          <CIcon
            v-if="item.isBlocked"
            name="cilLockLocked"
            class="icon block"
            size="lg"
          />
          <CIcon
            v-else
            name="cilLockUnlocked"
            class="icon block"
            size="lg"
          />
        </CButton>
      </td>
      <td v-else>Нет действий</td>
    </template>
    <template #loginDetails="{item}">
      <td>
        <span class="loginDetails" @click="editUser(item)">
          {{item.loginDetails}}
        </span>
      </td>
    </template>
  </CDataTable>
</template>

<script>
  import moment from 'moment'

  export default {
    name: "UsersTable",
    props: {
      tableData: {
        // Массив объектов с информацией о пользователях
        type: Array,
        default() {
          return [];
        },
      },
    },
    data() {
      return {
        fields: [
          {key: 'name', label: 'ФИО'},
          {key: 'role', label: 'Должность'},
          {key: 'status', label: 'Статус'},
          {key: 'email', label: 'Email'},
          {key: 'loginDetails', label: 'Данные для входа'},
          {key: 'createdAt', label: 'Дата добавления'},
          {key: 'actions', label: ''},
        ],
      };
    },
    computed: {
      items() {
        return this.tableData.reduce((resultTableData, dataItem) => {
          try {
            const {roles, blocked_at, created_at} = dataItem;
            const role = roles[0].name;
            const createdAt = moment(created_at).format('DD.MM.YYYY');
            const blockedAt = blocked_at ? moment(blocked_at).format('DD.MM.YYYY') : null;
            const status = blockedAt ? `Заблокирован ${blockedAt}` : 'Активен';
            const isBlocked = !!blockedAt;
            resultTableData.push({
              ...dataItem,
              role,
              status,
              createdAt,
              isBlocked,
              loginDetails: 'Подробнее',
            });
            return resultTableData;
          }
          catch (e) {
            console.error(e);
            return resultTableData;
          }
        }, [])
      },
    },
    methods: {
      addUser() {
        this.$emit('addUser');
      },
      deleteUser(item) {
        this.$emit('deleteUser', item);
      },
      blockUser(item) {
        this.$emit('blockUser', item);
      },
      editUser(item) {
        this.$emit('editUser', item);
      },
    }
  }
</script>
